#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 5;

int n,u,v,dp[MAXN],q,m;

bool b[MAXN];

vector<int> ch[MAXN];

int rek(int k)
{

    for(int i=0;i<ch[k].size();i++){
        dp[k]+=rek(ch[k][i])+1;
    }
    return dp[k];

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;

    for(int i=1;i<n;i++){

        cin>>u>>v;
        ch[u].push_back(v);
        b[v]=1;

    }

    for(int i=1;i<=n;i++){
        if(b[i]==0){
            //cout<<i;
            rek(i);
            break;
        }
    }

    cin>>q;

    for(int i=1;i<=q;i++){
        cin>>m;
        cout<<dp[m]<<'\n';
    }







    return 0;
}

